Erro classe inflar e android.support.v7.widget.CardView

? Harsh Pokharna @ | Original: StackOverFlow
---

Eu quero usar CardView no meu projeto, mas quando eu executar o meu pedido, eu recebo o seguinte erro . Eu estou usando Eclipse .

Error: Error inflating class and android.support.v7.widget.CardView

The graphical view of my xml file says 'The following classes could not be instantiated:
- android.support.v7.widget.CardView (Open Class, Show Error Log)
See the Error Log (Window > Show View) for more details.'

Please help.

Esse é o layout para o meu fragmento onde eu usei CardView

<FrameLayout xmlns:android="http://schemas.android.com/apk/res/android"
xmlns:tools="http://schemas.android.com/tools"
android:layout_width="match_parent"
android:layout_height="match_parent"
tools:context="com.example.log.MyContactsFragment" >

<!-- TODO: Update blank fragment layout -->

<android.support.v7.widget.CardView
    xmlns:card_view="http://schemas.android.com/apk/res-auto"
    android:id="@+id/cvContactDetails"
    android:layout_width="match_parent"
    android:layout_height="200dp"
    android:layout_gravity="center"
    android:background="?android:attr/selectableItemBackground"
    android:clickable="false"
    android:elevation="20dp" >

    <TextView
        android:id="@+id/tvContacts"
        android:layout_width="wrap_content"
        android:layout_height="wrap_content"
        android:text="Contact Info" />

    <Button
        android:id="@+id/bDelete"
        android:layout_width="wrap_content"
        android:layout_height="wrap_content"
        android:text="Delete" />

    <Button
        android:id="@+id/bExport"
        android:layout_width="wrap_content"
        android:layout_height="wrap_content"
        android:text="Export to phone contacts" />
</android.support.v7.widget.CardView>

Este é o layout para a minha atividade .

<?xml version="1.0" encoding="utf-8"?>
<android.support.v4.widget.DrawerLayout xmlns:android="http://schemas.android.com/apk/res/android"
    android:id="@+id/drawerLayout"
    android:layout_width="match_parent"
    android:layout_height="match_parent" >

    <FrameLayout
        android:id="@+id/flMainContent"
        android:layout_width="match_parent"
        android:layout_height="match_parent" >
    </FrameLayout>

    <ListView
        android:id="@+id/lvLeftDrawer"
        android:layout_width="200dp"
        android:layout_height="match_parent"
        android:layout_gravity="left"
        android:alpha="255"
        android:background="#0B2161"
        android:divider="@null"
        android:choiceMode="singleChoice" >
    </ListView>

    <ListView
        android:id="@+id/lvRightDrawer"
        android:layout_width="200dp"
        android:layout_height="match_parent"
        android:layout_gravity="right"
        android:alpha="255"
        android:background="#0B2161"
        android:divider="@null"
        android:choiceMode="singleChoice" >
    </ListView>

</android.support.v4.widget.DrawerLayout>

Este é o meu logcat

10-22 15:23:52.907: E/AndroidRuntime(696): FATAL EXCEPTION: main
10-22 15:23:52.907:   E/AndroidRuntime(696): java.lang.RuntimeException: Unable to start activity ComponentInfo{com.example.log/com.example.log.HomeScreenActivity}: android.view.InflateException: Binary XML file line #9: Error inflating class android.support.v7.widget.CardView
10-22 15:23:52.907: E/AndroidRuntime(696):  at android.app.ActivityThread.performLaunchActivity(ActivityThread.java:2059)
10-22 15:23:52.907: E/AndroidRuntime(696):  at android.app.ActivityThread.handleLaunchActivity(ActivityThread.java:2084)
10-22 15:23:52.907: E/AndroidRuntime(696):  at android.app.ActivityThread.access$600(ActivityThread.java:130)
10-22 15:23:52.907: E/AndroidRuntime(696):  at android.app.ActivityThread$H.handleMessage(ActivityThread.java:1195)
10-22 15:23:52.907: E/AndroidRuntime(696):  at android.os.Handler.dispatchMessage(Handler.java:99)
10-22 15:23:52.907: E/AndroidRuntime(696):  at android.os.Looper.loop(Looper.java:137)
10-22 15:23:52.907: E/AndroidRuntime(696):  at android.app.ActivityThread.main(ActivityThread.java:4745)
10-22 15:23:52.907: E/AndroidRuntime(696):  at java.lang.reflect.Method.invokeNative(Native Method)
10-22 15:23:52.907: E/AndroidRuntime(696):  at java.lang.reflect.Method.invoke(Method.java:511)
10-22 15:23:52.907: E/AndroidRuntime(696):  at com.android.internal.os.ZygoteInit$MethodAndArgsCaller.run(ZygoteInit.java:786)
10-22 15:23:52.907: E/AndroidRuntime(696):  at com.android.internal.os.ZygoteInit.main(ZygoteInit.java:553)
10-22 15:23:52.907: E/AndroidRuntime(696):  at dalvik.system.NativeStart.main(Native Method)
10-22 15:23:52.907: E/AndroidRuntime(696): Caused by: android.view.InflateException: Binary XML file line #9: Error inflating class android.support.v7.widget.CardView
10-22 15:23:52.907: E/AndroidRuntime(696):  at android.view.LayoutInflater.createView(LayoutInflater.java:613)
10-22 15:23:52.907: E/AndroidRuntime(696):  at android.view.LayoutInflater.createViewFromTag(LayoutInflater.java:687)
10-22 15:23:52.907: E/AndroidRuntime(696):  at android.view.LayoutInflater.rInflate(LayoutInflater.java:746)
10-22 15:23:52.907: E/AndroidRuntime(696):  at android.view.LayoutInflater.inflate(LayoutInflater.java:489)
10-22 15:23:52.907: E/AndroidRuntime(696):  at android.view.LayoutInflater.inflate(LayoutInflater.java:396)
10-22 15:23:52.907: E/AndroidRuntime(696):  at com.example.log.MyContactsFragment.onCreateView(MyContactsFragment.java:60)
10-22 15:23:52.907: E/AndroidRuntime(696):  at android.support.v4.app.Fragment.performCreateView(Fragment.java:1504)
10-22 15:23:52.907: E/AndroidRuntime(696):  at android.support.v4.app.FragmentManagerImpl.moveToState(FragmentManager.java:942)
10-22 15:23:52.907: E/AndroidRuntime(696):  at android.support.v4.app.FragmentManagerImpl.moveToState(FragmentManager.java:1121)
10-22 15:23:52.907: E/AndroidRuntime(696):  at android.support.v4.app.BackStackRecord.run(BackStackRecord.java:682)
10-22 15:23:52.907: E/AndroidRuntime(696):  at android.support.v4.app.FragmentManagerImpl.execPendingActions(FragmentManager.java:1484)
10-22 15:23:52.907: E/AndroidRuntime(696):  at android.support.v4.app.FragmentActivity.onStart(FragmentActivity.java:571)
10-22 15:23:52.907: E/AndroidRuntime(696):  at android.app.Instrumentation.callActivityOnStart(Instrumentation.java:1163)
10-22 15:23:52.907: E/AndroidRuntime(696):  at android.app.Activity.performStart(Activity.java:5018)
10-22 15:23:52.907: E/AndroidRuntime(696):  at android.app.ActivityThread.performLaunchActivity(ActivityThread.java:2032)
10-22 15:23:52.907: E/AndroidRuntime(696):  ... 11 more
10-22 15:23:52.907: E/AndroidRuntime(696): Caused by: java.lang.reflect.InvocationTargetException
10-22 15:23:52.907: E/AndroidRuntime(696):  at java.lang.reflect.Constructor.constructNative(Native Method)
10-22 15:23:52.907: E/AndroidRuntime(696):  at java.lang.reflect.Constructor.newInstance(Constructor.java:417)
10-22 15:23:52.907: E/AndroidRuntime(696):  at android.view.LayoutInflater.createView(LayoutInflater.java:587)
10-22 15:23:52.907: E/AndroidRuntime(696):  ... 25 more
10-22 15:23:52.907: E/AndroidRuntime(696): Caused by: java.lang.NoClassDefFoundError: android.support.v7.cardview.R$styleable
10-22 15:23:52.907: E/AndroidRuntime(696):  at android.support.v7.widget.CardView.initialize(CardView.java:203)
10-22 15:23:52.907: E/AndroidRuntime(696):  at android.support.v7.widget.CardView.<init>(CardView.java:101)
10-22 15:23:52.907: E/AndroidRuntime(696):  ... 28 more

Alguém que encontrou o mesmo problema ou resolvido, por favor, comente .

---

Top 5 Responder

1Harsh Pokharna @

Eu acho que eu posso responder a minha pergunta.

Vá em Arquivo -> Importar -> Código existente Android em espaço de trabalho -> Browse ( Ir para a SDK / extras / android / support / v7 / cardview ) - > clique em OK -> Clique em Concluir

Seu explorador projeto vai agora mostrar cardview como um projeto.

Clique direito sobre projeto cardview -> Propriedades - > (painel esquerdo) Android - > Habilitar isLibrary (assinalar a caixa de seleção ) - > Aplicar -> ok

Agora clique com o botão direito em seu projeto -> Propriedades - > Android (painel esquerdo) -> Adicionar ( sob biblioteca) -> cardview - > se candidatar -> ok

Agora clique com o direito no seu projeto novamente -> Caminho de Construção -> configure construir caminho -> Na guia projetos, adicione cardview

You are done.

2Bullest @

I obteve o erro passou Adicionando Dependências

Os widgets RecyclerView e CardView fazem parte das bibliotecas de apoio v7 . Para usar esses widgets em seu projeto, adicionar essas dependências gradle ao módulo de seu aplicativo :

dependências {     ...     compilar ' com.android.support:cardview-v7:21.0.+ '     compilar ' com.android.support:recyclerview-v7:21.0.+ ' }

http://developer.android.com/training/material/lists-cards.html

3Piyush Kukadiya @

No meu caso eu tenho que fazer as duas coisas acrescentar android.support.v7.widget.CardView, como um projeto de biblioteca e também adicionar + comprovar que está em arquivo jar java build path

Vá em Arquivo -> Importar -> Código existente Android em espaço de trabalho -> Browse ( Ir para a SDK / extras / android / support / v7 / cardview ) - > clique em OK -> Clique em Concluir

Clique direito sobre projeto cardview -> Propriedades - > (painel esquerdo) Android - > Habilitar isLibrary (assinalar a caixa de seleção ) - > Aplicar -> ok

Clique com o botão direito em seu projeto -> Propriedades - > Android (painel esquerdo) -> Adicionar ( sob biblioteca) -> cardview - > se candidatar -> ok

clique direito sobre o seu projecto de novo -> Caminho de Construção -> configure construir caminho - > em bibliotecas -> adicionar jar - > expandir cardview -> expandir libs -> selecione android.support.v7.widget.CardView.jar

sob ordem e exportação - > marque android.support.v7.widget.CardView.jar - > clique em ok

4Steven Elliott @

Eu desperdicei horas sobre isso, para mim, a peça final do quebra-cabeça estava indo para o projeto " cardview " que havia sido importado para o Eclipse como um projeto Android, clicando em seguida, direito> Propriedades > android> e mudá-lo a partir do Android 2.1 para pirulito!

5Arthur Wang @

Eu acho que o problema não está dentro do seu esquema xml, mas suas configurações build.gradle .

Quando você quiser usar a biblioteca de apoio para Recyclerview ou CardView em dispositivos API baixos, você não só precisa importar a biblioteca v7, mas também precisa de importar Recycler Vista e Cartão Ver suporte de forma independente.

Like this:

dependencies {
    compile fileTree(dir: 'libs', include: ['*.jar'])
    compile 'com.android.support:appcompat-v7:21.0.+'
    compile 'com.android.support:cardview-v7:21.0.+'
    compile 'com.android.support:recyclerview-v7:21.0.+'
    compile 'com.android.support:support-v4:21.0.0'
} 

Isso é notado por documentos do Google aqui: https://developer.android.com/training/material/compatibility.html

Consulte a seção dependências.

Além disso, você pode baixar a amostra do Google de RecyclerView para cavar .

Espero que isso vai ajudar!